# CloudCredentials

Configure your cloud credentials

## Get list of cloud provider credentials

> For a list of cloud providers see \[\`GET /v3/cloud/provider\`]\(#/Cloud/getCloudProviders)

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"CloudCredentials","description":"Configure your cloud credentials"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"CloudCredentials":{"type":"object","required":["providerId","name","params","createdAt","verifiedAt","credentialStatus","invalidateAt","invalidateReason","status"],"properties":{"providerId":{"type":"integer","format":"integer","description":"Cloud provider ID. For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/get_v3_cloud_provider)"},"name":{"type":"string","format":"","description":"User defined name for the cloud credential"},"params":{"anyOf":[{"$ref":"#/components/schemas/CloudCredentialsParamsAws"},{"$ref":"#/components/schemas/CloudCredentialsParamsAzure"},{"$ref":"#/components/schemas/CloudCredentialsParamsGcp"},{"$ref":"#/components/schemas/CloudCredentialsParamsUc"}],"description":"Cloud provider specific authentication params, in json format. [API examples](https://www.i3d.net/docs/one/odp/Cloud-Usage/Cloud-Credentials/#api-examples)"},"createdAt":{"type":"integer","format":"integer","description":"Unix timestamp of when credentials were first stored (informative only)","readOnly":true},"verifiedAt":{"type":"integer","format":"integer","description":"Unix timestamp of credential last verification time (informative only)","readOnly":true},"credentialStatus":{"type":"integer","format":"integer","description":"Status of cloud credential\n* 0: valid\n* 1: invalid","readOnly":true},"invalidateAt":{"type":"integer","format":"integer","description":"Unix timestamp of invalidation","readOnly":true},"invalidateReason":{"type":"string","format":"","description":"The reason for invalidation of the cloud credential","readOnly":true},"status":{"type":"integer","format":"integer","description":"Status of a currently in use cloud credential\n* 0: inactive\n* 1: active"}},"additionalProperties":false},"CloudCredentialsParamsAws":{"type":"object","required":["accessKeyId","secretAccessKey","defaultRegion","keyPair","securityGroup","isGameLift"],"properties":{"accessKeyId":{"type":"string","format":""},"secretAccessKey":{"type":"string","format":""},"defaultRegion":{"type":"string","format":"","description":"(regionName from [`GET /v3/cloud/provider/27/dcLocation`](#/Cloud/get_v3_cloud_provider__providerId__dcLocation))"},"keyPair":{"type":"string","format":"","nullable":true},"securityGroup":{"type":"string","format":"","nullable":true},"isGameLift":{"type":"boolean"}},"additionalProperties":false},"CloudCredentialsParamsAzure":{"type":"object","required":["tenantId","subscriptionId","clientId","clientSecretKey","resourceName","defaultRegion"],"properties":{"tenantId":{"type":"string","format":""},"subscriptionId":{"type":"string","format":""},"clientId":{"type":"string","format":""},"clientSecretKey":{"type":"string","format":""},"resourceName":{"type":"string","format":""},"defaultRegion":{"type":"string","format":"","description":"(regionName from [`GET /v3/cloud/provider/28/dcLocation`](#/Cloud/get_v3_cloud_provider__providerId__dcLocation))"}},"additionalProperties":false},"CloudCredentialsParamsGcp":{"type":"object","required":["projectName","network","authJson"],"properties":{"projectName":{"type":"string","format":""},"network":{"type":"string","format":""},"authJson":{"$ref":"#/components/schemas/CloudCredentialsParamsGcpAuthJson"}},"additionalProperties":false},"CloudCredentialsParamsGcpAuthJson":{"type":"object","required":["type","project_id","private_key_id","private_key","client_email","client_id","auth_uri","token_uri","auth_provider_x509_cert_url","client_x509_cert_url"],"properties":{"type":{"type":"string","format":""},"project_id":{"type":"string","format":""},"private_key_id":{"type":"string","format":""},"private_key":{"type":"string","format":""},"client_email":{"type":"string","format":""},"client_id":{"type":"string","format":""},"auth_uri":{"type":"string","format":""},"token_uri":{"type":"string","format":""},"auth_provider_x509_cert_url":{"type":"string","format":""},"client_x509_cert_url":{"type":"string","format":""}},"additionalProperties":false},"CloudCredentialsParamsUc":{"type":"object","required":["username","password","projectId","defaultRegion"],"properties":{"username":{"type":"string","format":""},"password":{"type":"string","format":""},"projectId":{"type":"string","format":""},"defaultRegion":{"type":"string","format":""},"keyPair":{"type":"string","format":""},"securityGroup":{"type":"string","format":""},"network":{"type":"string","format":""}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/cloud/configuration/credential":{"get":{"tags":["CloudCredentials"],"summary":"Get list of cloud provider credentials","description":"For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/getCloudProviders)","operationId":"getCloudConfigurationCredentials","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/CloudCredentials"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## Store new cloud provider credentials

> For a list of cloud providers see \[\`GET /v3/cloud/provider\`]\(#/Cloud/getCloudProviders).\
> In order to use your account for ODP you need to have permissions access, create and control instance templates and instances.\
> If you are not sure which permissions you need, please contact <info@i3d.net>.

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"CloudCredentials","description":"Configure your cloud credentials"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"CloudCredentials":{"type":"object","required":["providerId","name","params","createdAt","verifiedAt","credentialStatus","invalidateAt","invalidateReason","status"],"properties":{"providerId":{"type":"integer","format":"integer","description":"Cloud provider ID. For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/get_v3_cloud_provider)"},"name":{"type":"string","format":"","description":"User defined name for the cloud credential"},"params":{"anyOf":[{"$ref":"#/components/schemas/CloudCredentialsParamsAws"},{"$ref":"#/components/schemas/CloudCredentialsParamsAzure"},{"$ref":"#/components/schemas/CloudCredentialsParamsGcp"},{"$ref":"#/components/schemas/CloudCredentialsParamsUc"}],"description":"Cloud provider specific authentication params, in json format. [API examples](https://www.i3d.net/docs/one/odp/Cloud-Usage/Cloud-Credentials/#api-examples)"},"createdAt":{"type":"integer","format":"integer","description":"Unix timestamp of when credentials were first stored (informative only)","readOnly":true},"verifiedAt":{"type":"integer","format":"integer","description":"Unix timestamp of credential last verification time (informative only)","readOnly":true},"credentialStatus":{"type":"integer","format":"integer","description":"Status of cloud credential\n* 0: valid\n* 1: invalid","readOnly":true},"invalidateAt":{"type":"integer","format":"integer","description":"Unix timestamp of invalidation","readOnly":true},"invalidateReason":{"type":"string","format":"","description":"The reason for invalidation of the cloud credential","readOnly":true},"status":{"type":"integer","format":"integer","description":"Status of a currently in use cloud credential\n* 0: inactive\n* 1: active"}},"additionalProperties":false},"CloudCredentialsParamsAws":{"type":"object","required":["accessKeyId","secretAccessKey","defaultRegion","keyPair","securityGroup","isGameLift"],"properties":{"accessKeyId":{"type":"string","format":""},"secretAccessKey":{"type":"string","format":""},"defaultRegion":{"type":"string","format":"","description":"(regionName from [`GET /v3/cloud/provider/27/dcLocation`](#/Cloud/get_v3_cloud_provider__providerId__dcLocation))"},"keyPair":{"type":"string","format":"","nullable":true},"securityGroup":{"type":"string","format":"","nullable":true},"isGameLift":{"type":"boolean"}},"additionalProperties":false},"CloudCredentialsParamsAzure":{"type":"object","required":["tenantId","subscriptionId","clientId","clientSecretKey","resourceName","defaultRegion"],"properties":{"tenantId":{"type":"string","format":""},"subscriptionId":{"type":"string","format":""},"clientId":{"type":"string","format":""},"clientSecretKey":{"type":"string","format":""},"resourceName":{"type":"string","format":""},"defaultRegion":{"type":"string","format":"","description":"(regionName from [`GET /v3/cloud/provider/28/dcLocation`](#/Cloud/get_v3_cloud_provider__providerId__dcLocation))"}},"additionalProperties":false},"CloudCredentialsParamsGcp":{"type":"object","required":["projectName","network","authJson"],"properties":{"projectName":{"type":"string","format":""},"network":{"type":"string","format":""},"authJson":{"$ref":"#/components/schemas/CloudCredentialsParamsGcpAuthJson"}},"additionalProperties":false},"CloudCredentialsParamsGcpAuthJson":{"type":"object","required":["type","project_id","private_key_id","private_key","client_email","client_id","auth_uri","token_uri","auth_provider_x509_cert_url","client_x509_cert_url"],"properties":{"type":{"type":"string","format":""},"project_id":{"type":"string","format":""},"private_key_id":{"type":"string","format":""},"private_key":{"type":"string","format":""},"client_email":{"type":"string","format":""},"client_id":{"type":"string","format":""},"auth_uri":{"type":"string","format":""},"token_uri":{"type":"string","format":""},"auth_provider_x509_cert_url":{"type":"string","format":""},"client_x509_cert_url":{"type":"string","format":""}},"additionalProperties":false},"CloudCredentialsParamsUc":{"type":"object","required":["username","password","projectId","defaultRegion"],"properties":{"username":{"type":"string","format":""},"password":{"type":"string","format":""},"projectId":{"type":"string","format":""},"defaultRegion":{"type":"string","format":""},"keyPair":{"type":"string","format":""},"securityGroup":{"type":"string","format":""},"network":{"type":"string","format":""}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/cloud/configuration/credential":{"post":{"tags":["CloudCredentials"],"summary":"Store new cloud provider credentials","description":"For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/getCloudProviders).\nIn order to use your account for ODP you need to have permissions access, create and control instance templates and instances.\nIf you are not sure which permissions you need, please contact info@i3d.net.","operationId":"createCloudConfigurationCredential","requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CloudCredentials"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/CloudCredentials"}}}}},"403":{"description":"Invalid credentials"},"409":{"description":"Conflict"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## Get a list of cloud provider credentials for a given credential name

> For a list of cloud providers see \[\`GET /v3/cloud/provider\`]\(#/Cloud/getCloudProviders)

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"CloudCredentials","description":"Configure your cloud credentials"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"CloudCredentials":{"type":"object","required":["providerId","name","params","createdAt","verifiedAt","credentialStatus","invalidateAt","invalidateReason","status"],"properties":{"providerId":{"type":"integer","format":"integer","description":"Cloud provider ID. For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/get_v3_cloud_provider)"},"name":{"type":"string","format":"","description":"User defined name for the cloud credential"},"params":{"anyOf":[{"$ref":"#/components/schemas/CloudCredentialsParamsAws"},{"$ref":"#/components/schemas/CloudCredentialsParamsAzure"},{"$ref":"#/components/schemas/CloudCredentialsParamsGcp"},{"$ref":"#/components/schemas/CloudCredentialsParamsUc"}],"description":"Cloud provider specific authentication params, in json format. [API examples](https://www.i3d.net/docs/one/odp/Cloud-Usage/Cloud-Credentials/#api-examples)"},"createdAt":{"type":"integer","format":"integer","description":"Unix timestamp of when credentials were first stored (informative only)","readOnly":true},"verifiedAt":{"type":"integer","format":"integer","description":"Unix timestamp of credential last verification time (informative only)","readOnly":true},"credentialStatus":{"type":"integer","format":"integer","description":"Status of cloud credential\n* 0: valid\n* 1: invalid","readOnly":true},"invalidateAt":{"type":"integer","format":"integer","description":"Unix timestamp of invalidation","readOnly":true},"invalidateReason":{"type":"string","format":"","description":"The reason for invalidation of the cloud credential","readOnly":true},"status":{"type":"integer","format":"integer","description":"Status of a currently in use cloud credential\n* 0: inactive\n* 1: active"}},"additionalProperties":false},"CloudCredentialsParamsAws":{"type":"object","required":["accessKeyId","secretAccessKey","defaultRegion","keyPair","securityGroup","isGameLift"],"properties":{"accessKeyId":{"type":"string","format":""},"secretAccessKey":{"type":"string","format":""},"defaultRegion":{"type":"string","format":"","description":"(regionName from [`GET /v3/cloud/provider/27/dcLocation`](#/Cloud/get_v3_cloud_provider__providerId__dcLocation))"},"keyPair":{"type":"string","format":"","nullable":true},"securityGroup":{"type":"string","format":"","nullable":true},"isGameLift":{"type":"boolean"}},"additionalProperties":false},"CloudCredentialsParamsAzure":{"type":"object","required":["tenantId","subscriptionId","clientId","clientSecretKey","resourceName","defaultRegion"],"properties":{"tenantId":{"type":"string","format":""},"subscriptionId":{"type":"string","format":""},"clientId":{"type":"string","format":""},"clientSecretKey":{"type":"string","format":""},"resourceName":{"type":"string","format":""},"defaultRegion":{"type":"string","format":"","description":"(regionName from [`GET /v3/cloud/provider/28/dcLocation`](#/Cloud/get_v3_cloud_provider__providerId__dcLocation))"}},"additionalProperties":false},"CloudCredentialsParamsGcp":{"type":"object","required":["projectName","network","authJson"],"properties":{"projectName":{"type":"string","format":""},"network":{"type":"string","format":""},"authJson":{"$ref":"#/components/schemas/CloudCredentialsParamsGcpAuthJson"}},"additionalProperties":false},"CloudCredentialsParamsGcpAuthJson":{"type":"object","required":["type","project_id","private_key_id","private_key","client_email","client_id","auth_uri","token_uri","auth_provider_x509_cert_url","client_x509_cert_url"],"properties":{"type":{"type":"string","format":""},"project_id":{"type":"string","format":""},"private_key_id":{"type":"string","format":""},"private_key":{"type":"string","format":""},"client_email":{"type":"string","format":""},"client_id":{"type":"string","format":""},"auth_uri":{"type":"string","format":""},"token_uri":{"type":"string","format":""},"auth_provider_x509_cert_url":{"type":"string","format":""},"client_x509_cert_url":{"type":"string","format":""}},"additionalProperties":false},"CloudCredentialsParamsUc":{"type":"object","required":["username","password","projectId","defaultRegion"],"properties":{"username":{"type":"string","format":""},"password":{"type":"string","format":""},"projectId":{"type":"string","format":""},"defaultRegion":{"type":"string","format":""},"keyPair":{"type":"string","format":""},"securityGroup":{"type":"string","format":""},"network":{"type":"string","format":""}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/cloud/configuration/credential/{credentialName}":{"get":{"tags":["CloudCredentials"],"summary":"Get a list of cloud provider credentials for a given credential name","description":"For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/getCloudProviders)","operationId":"getCloudConfigurationCredential","parameters":[{"name":"credentialName","in":"path","description":"The user defined name for cloud credentials","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/CloudCredentials"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid credentialName"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/cloud/configuration/credential/{credentialName}

> Update name and status of credential.

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"CloudCredentials","description":"Configure your cloud credentials"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"CloudCredentialsMetaData":{"type":"object","required":["name","status"],"properties":{"name":{"type":"string","format":"","description":"User defined name for the cloud credential"},"status":{"type":"integer","format":"integer","description":"Status of a cloud credential\n* 0: inactive\n* 1: active"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/cloud/configuration/credential/{credentialName}":{"put":{"tags":["CloudCredentials"],"summary":"Update name and status of credential.","operationId":"updateCloudConfigurationCredential","parameters":[{"name":"credentialName","in":"path","description":"The user defined name for cloud credentials.","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CloudCredentialsMetaData"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/CloudCredentialsMetaData"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid credentialName"},"409":{"description":"Name already exists"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## Delete a cloud provider credential for a given name

> For a list of cloud providers see \[\`GET /v3/cloud/provider\`]\(#/Cloud/getCloudProviders)

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"CloudCredentials","description":"Configure your cloud credentials"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/cloud/configuration/credential/{credentialName}":{"delete":{"tags":["CloudCredentials"],"summary":"Delete a cloud provider credential for a given name","description":"For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/getCloudProviders)","operationId":"deleteCloudConfigurationCredential","parameters":[{"name":"credentialName","in":"path","description":"The user defined name for cloud credentials.","required":true,"schema":{"type":"string"}}],"responses":{"204":{"description":"No Content"},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid credentialName"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## Validate cloud provider credentials

> For a list of cloud providers see \[\`GET /v3/cloud/provider\`]\(#/Cloud/getCloudProviders).\
> In order to use your account for the One Platform you need to have permissions to access, create and control instance templates and instances.\
> If you are not sure which permissions you need, please contact <info@i3d.net>. This endpoint only validates provided cloud credentials, this action won't create new\
> cloud credentials for your user (to do so please refer to \[\`POST /cloud/configuration/credential\`]\(#/CloudCredentials/createCloudConfigurationCredential))

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"CloudCredentials","description":"Configure your cloud credentials"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"CloudCredentialsValidation":{"type":"object","required":["providerId","params"],"properties":{"providerId":{"type":"integer","format":"integer","description":"Cloud provider ID. For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/get_v3_cloud_provider)"},"params":{"anyOf":[{"$ref":"#/components/schemas/CloudCredentialsParamsAws"},{"$ref":"#/components/schemas/CloudCredentialsParamsAzure"},{"$ref":"#/components/schemas/CloudCredentialsParamsGcp"},{"$ref":"#/components/schemas/CloudCredentialsParamsUc"}],"description":"Cloud provider specific authentication params, in json format. [API examples](https://www.i3d.net/docs/one/odp/Cloud-Usage/Cloud-Credentials/#api-examples)"}},"additionalProperties":false},"CloudCredentialsParamsAws":{"type":"object","required":["accessKeyId","secretAccessKey","defaultRegion","keyPair","securityGroup","isGameLift"],"properties":{"accessKeyId":{"type":"string","format":""},"secretAccessKey":{"type":"string","format":""},"defaultRegion":{"type":"string","format":"","description":"(regionName from [`GET /v3/cloud/provider/27/dcLocation`](#/Cloud/get_v3_cloud_provider__providerId__dcLocation))"},"keyPair":{"type":"string","format":"","nullable":true},"securityGroup":{"type":"string","format":"","nullable":true},"isGameLift":{"type":"boolean"}},"additionalProperties":false},"CloudCredentialsParamsAzure":{"type":"object","required":["tenantId","subscriptionId","clientId","clientSecretKey","resourceName","defaultRegion"],"properties":{"tenantId":{"type":"string","format":""},"subscriptionId":{"type":"string","format":""},"clientId":{"type":"string","format":""},"clientSecretKey":{"type":"string","format":""},"resourceName":{"type":"string","format":""},"defaultRegion":{"type":"string","format":"","description":"(regionName from [`GET /v3/cloud/provider/28/dcLocation`](#/Cloud/get_v3_cloud_provider__providerId__dcLocation))"}},"additionalProperties":false},"CloudCredentialsParamsGcp":{"type":"object","required":["projectName","network","authJson"],"properties":{"projectName":{"type":"string","format":""},"network":{"type":"string","format":""},"authJson":{"$ref":"#/components/schemas/CloudCredentialsParamsGcpAuthJson"}},"additionalProperties":false},"CloudCredentialsParamsGcpAuthJson":{"type":"object","required":["type","project_id","private_key_id","private_key","client_email","client_id","auth_uri","token_uri","auth_provider_x509_cert_url","client_x509_cert_url"],"properties":{"type":{"type":"string","format":""},"project_id":{"type":"string","format":""},"private_key_id":{"type":"string","format":""},"private_key":{"type":"string","format":""},"client_email":{"type":"string","format":""},"client_id":{"type":"string","format":""},"auth_uri":{"type":"string","format":""},"token_uri":{"type":"string","format":""},"auth_provider_x509_cert_url":{"type":"string","format":""},"client_x509_cert_url":{"type":"string","format":""}},"additionalProperties":false},"CloudCredentialsParamsUc":{"type":"object","required":["username","password","projectId","defaultRegion"],"properties":{"username":{"type":"string","format":""},"password":{"type":"string","format":""},"projectId":{"type":"string","format":""},"defaultRegion":{"type":"string","format":""},"keyPair":{"type":"string","format":""},"securityGroup":{"type":"string","format":""},"network":{"type":"string","format":""}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/cloud/configuration/credential/validate":{"post":{"tags":["CloudCredentials"],"summary":"Validate cloud provider credentials","description":"For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/getCloudProviders).\nIn order to use your account for the One Platform you need to have permissions to access, create and control instance templates and instances.\nIf you are not sure which permissions you need, please contact info@i3d.net. This endpoint only validates provided cloud credentials, this action won't create new\ncloud credentials for your user (to do so please refer to [`POST /cloud/configuration/credential`](#/CloudCredentials/createCloudConfigurationCredential))","operationId":"createCloudConfigurationCredentialValidate","requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CloudCredentialsValidation"}}},"required":true},"responses":{"204":{"description":"No Content"},"403":{"description":"Invalid credentials"},"409":{"description":"Conflict"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.i3d.net/api-references/game/cloudcredentials-1.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
